/*
#include <algorithm>
#include <vector>
#include <string>
using namespace std;
*/

// #if 0
// algorithm

int max(int a, int b) { return a>b?a:b; }
int min(int a, int b) { return a<b?a:b; }
template<class T> void swap(T& x, T& y) { T z; z=x; x=y; y=z; }
template<class T> void stable_sort(T* a, T* b, bool less(const T& x, const T& y)) {
  T *p = a;
  while(p < b) {
    if(p == a) p++;
    else if(less(p[0], p[-1])) { swap(p[0], p[-1]); p--; }
    else p++;
    }
  }

// string

template<int STRSIZE> struct sstring {
  static const int STRSIZ = STRSIZE-1;
  static const int npos = 999;
  char b[STRSIZE];
  char& operator [] (int i) { return b[i]; }
  const char& operator [] (int i) const { return b[i]; }
  char* c_str() { return b; }
  int size() const { for(int k=0; k<STRSIZE; k++) if(b[k] == 0) return k; return STRSIZE; }
  void operator = (const char* x) {
    int i = 0;
    while(i < STRSIZ && *x) { b[i] = *x; i++; x++; }
    b[i] = 0;
    }
  sstring () { b[0] = 0; }
  sstring (const char* x) {
    int i = 0;
    while(i < STRSIZ && *x) { b[i] = *x; i++; x++; }
    b[i] = 0;
    }
  sstring (char x) { b[0] = x; b[1] = 0; }
  sstring (int qty, char x) { if(qty>STRSIZ) qty=STRSIZ; for(int i=0; i<qty; i++) b[i] = x; b[qty] = 0; }
  sstring substr(int from, int qty = npos) {
    sstring res;
    if(from+qty > STRSIZ) qty = STRSIZ-from;
    for(int k=0; k<qty; k++) res[k] = b[from+k];
    res[qty] = 0;
    return res;
    }
  int find(const sstring& s) { return npos; }
  void replace(int at, int qty, const sstring& s) { }
  };

template<int X, int Y> void operator+= (sstring<X>& a, const sstring<Y>& b) {
  int pa=0, pb=0;
  while(a[pa]) pa++;
  while(b[pb] && pa < a.STRSIZ)
    a[pa] = b[pb], pa++, pb++;
  a[pa] = 0;
  }

template<int X> void operator+= (sstring<X>& a, const char *b) { 
  a += sstring<X> (b);
  }
  
template<int X> void operator+= (sstring<X>& a, char b) { 
  a += sstring<X> (b);
  }
  
template<int X, int Y> sstring<X> operator+ (const sstring<X>& a, const sstring<Y>& b) {
  sstring<X> res;
  int pa=0, pb=0;
  while(a[pa]) res[pa] = a[pa], pa++;
  while(b[pb] && pa < a.STRSIZ) res[pa] = b[pb], pa++, pb++;
  res[pa] = 0;
  return res;
  }

template<int X> sstring<X> operator+ (const sstring<X>& a, const char *b) {
  sstring<X> res;
  int pa=0;
  while(a[pa]) res[pa] = a[pa], pa++;
  while(*b && pa < a.STRSIZ) res[pa] = b[0], pa++, b++;
  res[pa] = 0;
  return res;
  }

template<int X> sstring<X> operator+ (const sstring<X>& a, char b) {
  sstring<X> res;
  int pa=0;
  while(a[pa]) res[pa] = a[pa], pa++;
  if(pa < a.STRSIZ) res[pa] = b, pa++;
  res[pa] = 0;
  return res;
  }

template<int X> sstring<X> operator+ (const char *a, const sstring<X>& b) {
  return sstring<X>(a) + b;
  }

template<int X> sstring<X> operator+ (const char x, const sstring<X>& b) {
  return sstring<X>(x) + b;
  }

template<int X, int Y> bool operator== (const sstring<X>& a, const sstring<Y>& b) {
  int i = 0;
  while(a[i] && a[i] == b[i]) i++;
  return a[i] == b[i];
  }
  
template<int X, int Y> bool operator!= (const sstring<X>& a, const sstring<Y>& b) {
  int i = 0;
  while(a[i] && a[i] == b[i]) i++;
  return a[i] != b[i];
  }

template<int X> bool operator!= (const sstring<X>& a, const char *b) {
  int i = 0;
  while(a[i] && a[i] == b[i]) i++;
  return a[i] != b[i];
  }

typedef sstring<2000> string;

// vector

template<class T> struct vector {
  int qsize, capacity;
  T* arr;
  vector() { qsize = 0; capacity = 16; arr = new T[16]; }
  vector(const vector& w) { 
    qsize = w.qsize; capacity = w.capacity; arr = new T[w.capacity]; 
    for(int i=0; i<qsize; i++) arr[i] = w.arr[i];
    }
  void operator = (const vector& w) {
    qsize = w.qsize; capacity = w.capacity; arr = new T[w.capacity]; 
    for(int i=0; i<qsize; i++) arr[i] = w.arr[i];
    }
  ~vector() { delete [] arr; }
  T& operator[] (int i) { return arr[i]; }
  const T& operator[] (int i) const { return arr[i]; }
  void reserve(int newcap) {
    if(newcap <= capacity) return;
    while((newcap & (newcap-1))) newcap &= (newcap-1);
    newcap *= 2;
    if(newcap < 16) newcap = 16;
    T* narr = new T[newcap];
    for(int i=0; i<qsize; i++) narr[i] = arr[i];
    delete[] arr;
    arr = narr;
    capacity = newcap;
    }
  void resize(int newqsize) { 
    reserve(newqsize); qsize = newqsize;
    }
  void push_back(const T& x) {
    resize(qsize+1);
    arr[qsize-1] = x;
    }
  T* begin() { return arr; }
  T* end() { return arr+qsize; }
  void insert(T* where, const T& what) {
    T* w2 = end();
    resize(qsize+1);
    while(w2 != where) {w2--; w2[1] = w2[0]; }
    where[0] = what;
    }
  void clear() { qsize = 0; }
  bool empty() { return qsize == 0; }
  int size() const { return qsize; }
  };
                                    
template<class T> void swap(vector<T>& x, vector<T>& y) {
  swap(x.qsize, y.qsize);
  swap(x.capacity, y.capacity);
  swap(x.arr, y.arr);
  }

// complex

template<class T> struct complex {
  T r, i;
  complex () { r=0; i=0; }
  complex (T R) { r=R; i=0; }
  complex (T R, T I) { r=R; i=I; }
  };

template <class T> T abs(complex<T> z) { return sqrt(z.r*z.r+z.i*z.i); }

template <class T> complex<T> operator * (const complex<T>& a, const complex<T>& b) {
  return complex<T> (a.r*b.r-a.i*b.i, a.r*b.i+a.i*b.r);
  }

template <class T> complex<T> operator + (const complex<T>& a, const complex<T>& b) {
  return complex<T> (a.r+b.r, a.i+b.i);
  }

// pair

template<class T, class U> struct pair {
  T first;
  U second;
  pair(T t, U u) : first(t), second(u) {}
  pair() {}
  };

template<class T, class U> pair<T,U> make_pair(const T& t, const U& u) {
  return pair<T,U> (t,u);
  }

// #endif
